﻿using System;
using System.Collections.Generic;
using SunshineConsole;
using OpenTK.Graphics;
using OpenTK.Input;
using Utilities;
using PosArrays;
namespace DijkstraVisualizer{
	public static partial class DijkstraMain{
		public static int rows = 20; //56 x 160 fits the screen well
		public static int cols = 50;
		public static void Main(){
			/*Bitmap bmp = new Bitmap("font8x16.bmp");
			PixelFormat pxf = bmp.PixelFormat;
			BitmapData bmp_data = bmp.LockBits(new Rectangle(0,0,bmp.Width,bmp.Height),ImageLockMode.ReadWrite,pxf);
			IntPtr ptr = bmp_data.Scan0;
			int bytes = Math.Abs(bmp_data.Stride) * bmp.Height;
			byte[] v = new byte[bytes];
			Marshal.Copy(ptr,v,0,bytes);
			byte[] v2 = new byte[bytes / 9 * 8];
			int i2 = 0;
			for(int i=0;i<bytes;++i){
				if(i % 9 == 8){
					continue; //increase i but not i2
				}
				v2[i2] = v[i];
				i2++;
			}
			Bitmap dest = new Bitmap(bmp.Width / 9 * 8,bmp.Height);
			BitmapData data2 = dest.LockBits(new Rectangle(0,0,dest.Width,dest.Height),ImageLockMode.ReadWrite,pxf);
			IntPtr ptr2 = data2.Scan0;
			Marshal.Copy(v2,0,ptr2,bytes / 9 * 8);
			bmp.UnlockBits(bmp_data);
			dest.UnlockBits(data2);
			dest.Save("font8x16_numbertwo.bmp");
			return;*/
			ConsoleWindow cw;
			Run(6,out cw);
		}
		public static void Draw(ConsoleWindow cw,PosArray<int> dijk,PosArray<char> map){
			Draw(cw,dijk,map,dijk.GetMax(),dijk.GetMin());
		}
		public static void Draw(ConsoleWindow cw,PosArray<int> dijk,PosArray<char> map,int max_dist,int min_dist){
			for(int i=0;i<rows;++i){
				for(int j=0;j<cols;++j){
					Color4 bgcolor = SmoothColorFromDistance(dijk[i,j],max_dist,min_dist);
					Color4 color = Color4.Black;
					char ch = map[i,j];
					if(ch == '.' || ch == ',' || ch == ' ' || ch == '~'){
						if(ch == ','){
							color = Color4.Aquamarine;
						}
						if(ch == '~'){
							bgcolor = Color4.Aqua;
						}
						//ch = NormalizedCharFromDistance(dijk[i,j],min_dist);
						ch = CharFromDistance(dijk[i,j]);
					}
					if(ch == 'g'){
						color = Color4.Lime;
					}
					if(ch == 'r'){
						color = Color4.YellowGreen;
					}
					if(ch == '$'){
						color = Color4.DarkBlue;
					}
					if(dijk[i,j].IsValidDijkstraValue()){
						if(dijk[i,j] < 0){
							color = Color4.Gray;
						}
					}
					else{
						bgcolor = Color4.Black;
						color = Color4.White;
					}
					cw.Write(i,j,ch,color,bgcolor);
				}
			}
			while(cw.Refresh()){
				Key k = cw.GetKey();
				if(k == Key.Space){
					break;
				}
				if(k == Key.Escape){
					Environment.Exit(0);
				}
				System.Threading.Thread.Sleep(200);
			}
		}
		public static void Draw2(ConsoleWindow cw,PosArray<int> dijk,PosArray<char> map,int max_dist,int min_dist){
			for(int i=0;i<rows;++i){
				for(int j=0;j<cols;++j){
					Color4 bgcolor = Color4.White; //SmoothColorFromDistance(dijk[i,j],max_dist,min_dist);
					Color4 color = Color4.Black;
					char ch = map[i,j];
					if(ch == '.' || ch == ',' || ch == ' ' || ch == '~'){
						if(ch == ','){
							color = Color4.Aquamarine;
						}
						if(ch == '~'){
							bgcolor = Color4.Aqua; //TODO: NEXT: i changed these values to get water-crossing pathfinding working, so 
						} // create these images and reset this stuff. The first image is ready. what other one(s) do i want? (is there a good one that 
						if(ch == '.'){ // shows the travel restrictions?)
							bgcolor = Color4.GreenYellow;
						}
						//ch = NormalizedCharFromDistance(dijk[i,j],min_dist);
						ch = CharFromDistance(dijk[i,j]);
					}
					if(ch == 'g'){
						color = Color4.Lime;
					}
					if(ch == 'r'){
						color = Color4.YellowGreen;
					}
					if(ch == '$'){
						color = Color4.DarkBlue;
					}
					if(dijk[i,j].IsValidDijkstraValue()){
						if(dijk[i,j] < 0){
							color = Color4.Gray;
						}
					}
					else{
						bgcolor = Color4.Black;
						color = Color4.White;
					}
					cw.Write(i,j,ch,color,bgcolor);
				}
			}
			while(cw.Refresh()){
				Key k = cw.GetKey();
				if(k == Key.Space){
					break;
				}
				if(k == Key.Escape){
					Environment.Exit(0);
				}
				System.Threading.Thread.Sleep(200);
			}
		}
		public static void Draw3(ConsoleWindow cw,PosArray<int> dijk,PosArray<char> map){
			Draw3(cw,dijk,map,dijk.GetMax(),dijk.GetMin());
		}
		public static void Draw3(ConsoleWindow cw,PosArray<int> dijk,PosArray<char> map,int max_dist,int min_dist){
			for(int i=0;i<rows;++i){
				for(int j=0;j<cols;++j){
					Color4 bgcolor = SmoothColorFromDistance(dijk[i,j],max_dist,min_dist);
					Color4 color = Color4.Black;
					char ch = map[i,j];
					if(ch == '.' || ch == ',' || ch == ' ' || ch == '~'){
						if(ch == ','){
							color = Color4.Aquamarine;
						}
						//ch = NormalizedCharFromDistance(dijk[i,j],min_dist);
						ch = CharFromDistance(dijk[i,j]);
						if(map[i,j] == '~'){
							ch = '~';
						}
						if(map[i,j] == '.'){
							ch = ' ';
						}
					}
					if(ch == 'g'){
						color = Color4.Lime;
					}
					if(ch == 'r'){
						color = Color4.YellowGreen;
					}
					if(ch == '$'){
						color = Color4.DarkBlue;
					}
					if(dijk[i,j].IsValidDijkstraValue()){
						if(dijk[i,j] < 0){
							color = Color4.Gray;
						}
					}
					else{
						bgcolor = Color4.Black;
						color = Color4.White;
					}
					cw.Write(i,j,ch,color,bgcolor);
				}
			}
			while(cw.Refresh()){
				Key k = cw.GetKey();
				if(k == Key.Space){
					break;
				}
				if(k == Key.Escape){
					Environment.Exit(0);
				}
				System.Threading.Thread.Sleep(200);
			}
		}
		public static int GetMax(this PosArray<int> dijk){
			var valid = dijk.PositionsWhere(x=>dijk[x].IsValidDijkstraValue()).WhereGreatest(x=>dijk[x]);
			if(valid.Count > 0){
				return dijk[valid[0]];
			}
			return U.DijkstraMin;
		}
		public static int GetMin(this PosArray<int> dijk){
			var valid = dijk.PositionsWhere(x=>dijk[x].IsValidDijkstraValue()).WhereLeast(x=>dijk[x]);
			if(valid.Count > 0){
				return dijk[valid[0]];
			}
			return U.DijkstraMax;
		}
		/*public static char CharFromDistance(int dist,int min_dist = 0){ return CharFromDistance2(dist,min_dist);
			int idx = 0;
			if(dist < 0){
				idx = 1;
			}
			return ((dist - min_dist) % 10).ToString()[idx];
		}*/
		public static char CharFromDistance(int dist){
			int d = Math.Abs(dist) % 36;
			if(d < 10){
				return d.ToString()[0];
			}
			else{
				return (char)((d-10) + (int)'A');
			}
		}
		public static char NormalizedCharFromDistance(int dist,int min_dist){ //return ' ';
			int d = (dist - min_dist) % 36;
			if(d < 10){
				return d.ToString()[0];
			}
			else{
				return (char)((d-10) + (int)'A');
			}
		}
		/*public static Color4 SmoothColorFromDistance(int dist,int max_dist,int min_dist = 0){ return SmoothColorFromDistance2(dist,max_dist,min_dist);
			int steps = (max_dist - min_dist) / 3;
			if(steps < 1){
				steps = 1;
			}
			int d = dist - min_dist;
			if(d < steps){
				return new Color4(1.0f,1.0f - (1.0f / (float)steps) * d,0.0f,1.0f); //yellow to red
			}
			if(d < steps*2){
				return new Color4(1.0f,0.0f,0.0f + (1.0f / (float)steps) * (d-steps),1.0f); //red to magenta
			}
			return new Color4(1.0f - (1.0f / (float)steps) * (d-steps*2),0.0f,1.0f,1.0f); //magenta to blue
		}*/
		public static Color4 SmoothColorFromDistance(int dist,int max_dist,int min_dist = 0){
			float f = (float)(dist - min_dist) / (float)(max_dist - min_dist); //yellow, red, magenta, blue
			return new Color4(1.0f - 3.0f * (f - 2.0f / 3.0f),1.0f - 3.0f * f,3.0f * (f - 1.0f / 3.0f),1.0f);
		}
		public static Color4 DiscreteColorFromDistance(int dist){
			//float b = 1.0f - (float)dist * 0.008f;
			//return new Color4(b,b,b,1.0f);
			const int steps = 6;
			const int color_steps = 6;
			if(dist < steps){
				return new Color4(1.0f,1.0f,1.0f - (1.0f / (float)steps) * dist,1.0f); //white to yellow
			}
			int aa = (dist-steps) / (color_steps*steps);
			float a = 0.1f * aa;
			dist = ((dist-steps) % (color_steps*steps)) + steps;
			if(dist < steps*2){
				return new Color4(1.0f - (1.0f / (float)steps) * (dist-steps),1.0f,0.0f,1.0f).Darken(a); //yellow to green
			}
			if(dist < steps*3){
				return new Color4(0.0f,1.0f,0.0f + (1.0f / (float)steps) * (dist-steps*2),1.0f).Darken(a); //green to cyan
			}
			if(dist < steps*4){
				return new Color4(0.0f,1.0f - (1.0f / (float)steps) * (dist-steps*3),1.0f,1.0f).Darken(a); //cyan to blue
			}
			if(dist < steps*5){
				return new Color4(0.0f + (1.0f / (float)steps) * (dist-steps*4),0.0f,1.0f,1.0f).Darken(a); //blue to magenta
			}
			if(dist < steps*6){
				return new Color4(1.0f,0.0f,1.0f - (1.0f / (float)steps) * (dist-steps*5),1.0f).Darken(a); //magenta to red
			}
			return new Color4(1.0f,0.0f + (1.0f / (float)steps) * (dist-steps*6),0.0f,1.0f).Darken(a); //red to yellow
		}
		public static Color4 Darken(this Color4 color,float darkness){ //1.0 will turn the color completely black.
			float f = 1.0f - darkness;
			return new Color4(color.R * f,color.G * f,color.B * f,color.A);
		}
		public static bool Refresh(this ConsoleWindow c){
			if(c.WindowUpdate()){
				return true;
			}
			Environment.Exit(0);
			return false;
		}
	}
}

