﻿using System;
using PosArrays;
namespace DijkstraVisualizer{
	public static partial class DijkstraMain{
		public static PosArray<char> GetMap(int n){
			string[] s = GetRawMap(n);
			rows = s.Length;
			cols = s[0].Length;
			var map = new PosArray<char>(rows,cols);
			for(int i=0;i<rows;++i){
				for(int j=0;j<cols;++j){
					map[i,j] = s[i][j];
					if(i==0 || j==0 || i==rows-1 || j==cols-1){
						//map[i,j] = '#';
					}
				}
			}
			return map;
		}
		public static string[] GetRawMap(int i){
			// player		@
			// floor		.
			// wall			#
			// goblin		g
			// 
			var s = new string[][]{
				new string[]{ //0
					"................$$$$..............................",
					".................$............................$...",
					"..................................................",
					"..$...............................................",
					"..................................................",
					"............................@.....................",
					"..................................................",
					"..................................................",
					"..........$.......................................",
					"..................................................",
					"..................................................",
					"...$..............................................",
					".....................$............................",
					".......$..........................................",
					"..................................................",
					"..................................................",
					".......$..........................................",
					"...........................$......................",
					"..................................................",
					"..................................................",},
				new string[]{ //1
					".................",
					"......g..........",
					"....#####........",
					"......@.#....g...",
					"........#........",
					"........#........",
					".................",
					".................",
					".g...............",
					"#################",
					"Note that every  ",
					"goblin can 'roll ",
					"downhill' to find",
					"the player       ",
				},
				new string[]{ //2
					"................................",
					"................................",
					"................................",
					"................................",
					"....................@...........",
					"................................",
					".......##################.......",
					"................................",
					"................................",
					"................................",
					"................................",
					"................................",},
				new string[]{ //3
					".......................#.......",
					"........@...........g..........",
					".......................#.......",
					"###############################",
					".......................#.......",
					"..............@...........g....",
					".......................#.......",
					"###############################",
					".......................#.......",
					"..................@...........g",
					".......................#.......",
					"###############################",
					".......................#.......",
					"......................@.......g",
					".......................#.......",
					"###############################",
					".......................#.......",
					".......................@......g",
					".......................#.......",
					"###############################",
					".......................#.......",
					"........................@.....g",
					".......................#.......",
					"###############################",
					".......................#.......",
					".........................@....g",
					".......................#.......",
					"###############################",
					".......................#.......",
					"..........................@...g",
					".......................#.......",
					"###############################",
					".......................#.......",
					"...........................@..g",
					".......................#.......",
					"###############################",
					".......................#.......",
					"............................@g.",
					".......................#.......",
					"###############################",
					".......................#....g..",
					"............................@..",
					".......................#.......",
					"###############################",},
				new string[]{ //4
					"......................",
					".......#..............",
					"..######..............",
					"...r#..#..............",
					"..@.#.................",
					".......#####..........",
					"...........#..........",
					"....r......#..........",
					".....#.....#..........",
					".....#................",},
				new string[]{ //5
					".................",
					".................",
					".................",
					".................",
					".........@.......",
					".................",
					".................",
					".................",
					".................",
					".................",
					".................",},
				new string[]{ //6
					".................",
					".................",
					".g...............",
					"........@.....g..",
					"..........g......",
					".................",
					".................",
					".................",
					".....g...........",
					".................",
					".................",},
				new string[]{ //7
					"##################################################",
					"#................###########.................#####",
					"#................###########.................#####",
					"#................###########.................#####",
					"#........@.......###########.................#####",
					"#.........................##.....................#",
					"#................########....................###.#",
					"#................###########.................###.#",
					"#................###############################.#",
					"##########..###################################..#",
					"##########..###################################.##",
					"##########..#################################...##",
					"##########..#################################.####",
					"##########..#################################.####",
					"##########..###########...############......#.####",
					"#########....#########......##########........####",
					"######..........#######......#########......######",
					"######..................###...########......######",
					"######..........#############...............######",
					"#########....#########################......######",
					"##################################################",
					"##################################################",},
				new string[]{ //8
					"########################################",
					"#................###########...........#",
					"#................###########...........#",
					"#................###########...........#",
					"#........@.......###########...........#",
					"#.........................##...........#",
					"#................########..............#",
					"#................###########...........#",
					"#................##################.####",
					"##########..#######################.####",
					"##########..##################......####",
					"##########..#############......#########",
					"##########..#############.##############",
					"##########..#############.##############",
					"##########..###########...##############",
					"#########....#########......############",
					"######..........#######......###########",
					"######..................###...##########",
					"######..........############..##########",
					"#########....###########################",
					"########################################",
					"########################################",},
				new string[]{ //9
					"............#...................",
					"............#...................",
					"....W..#....#...................",
					".......#....#...................",
					"...#####............@...#.......",
					".......#................#.......",
					".......##################.......",
					"................................",
					"................................",
					"................................",
					"................................",
					"................................",},
				new string[]{ //10
					"#######                         ",
					"#.....########                  ",
					"#...@........#                  ",
					"#.....###### #                  ",
					"###.###                         ",
					"  #.#                           ",
					" ##.######                      ",
					" #.......#                      ",
					" #.......########               ",
					" #..............+               ",
					" ################               ",
					"                                ",},
				new string[]{ //11
					"#######                         ",
					"#.....########                  ",
					"#............#                  ",
					"#.....######@#                  ", //i don't think these extras are necessary. autoexplore is really straightforward.
					"###.###  #.....#                ",
					"  #.#    #.###.#                ",
					" ##.######                      ",
					" #.......#                      ",
					" #.......#                      ",
					" #.......#                      ",
					" #########                      ",
					"                                ",},
				new string[]{ //12
					"#######                         ",
					"#.....########                  ",
					"#...@........#                  ", //(but this one is used for something)
					"#...,.######.#                  ",
					"###,###                         ",
					"  #,#                           ",
					" ##,######                      ",
					" #..,,,!.#                      ",
					" #.......########               ",
					" #..............+               ",
					" ################               ",
					"                                ",},
				new string[]{ //13
					"#######                         ",
					"#.....########  !               ",
					"#...@,,,,,,,.# ,                ", //(but this one is used for something)
					"#.....######,#,                 ",
					"###.###      ,                  ",
					"  #.#                           ",
					" ##.######                      ",
					" #.......#                      ",
					" #.......########               ",
					" #..............+               ",
					" ################               ",
					"                                ",},
				new string[]{ //14
					"............#...................",
					"............#...................",
					"....W..#....#...................",
					".......#....#...................",
					"...#####............@...#.......",
					".......#................#.......",
					".......##################.......",
					"................................",
					"................................",
					"................................",
					"................................",
					"................................",},
				new string[]{ //15
					"~~~~~~~~~~~~~~.........................................................",
					"~~~~~~~~~~~~~~.........................................................",
					"~~~~~~~~~~~~~.......................................................~~~",
					"~~~~~~~~~~~~.........~~~...........................................~~~~",
					"~~~~~~~~~~~~........~~~~...........................................~~~~",
					"~~~~~~~~~~~........~~~~~............................................~~~",
					"~~~~~~~~~.........~~................................................~~~",
					"~~~~~~~..........~~.................................................~~~",
					"~~~~~...........~~..................................................~~~",
					"..............~~~................~~~~~~....~~~~~~~~~................~~~",
					"............~~~..................~~~~~~~~...~~~~~~~~~~~~.............~~",
					"...........~~~..............~~~~~~~~~~~~~~~~~~~~~~~~~~~~~..............",
					"...........~~.............~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~..............",
					"...........................~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~..............",
					"..........................~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~...............",
					"...........................~~~~~~~~~~~~~~~~~~~~~~~~~~~~~...............",
					".........................~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~...............",
					"........................~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~...............",
					"........................~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~................",
					"........................~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~.................",
					"........................~~~~~~~~~~~~~~~~~~~~~~~~~~~~~...~~.............",
					".........................~~~~~~~~~~~~~~~~~~~~~~~~~~~...~~~~............",
					".....~~...................~~~~~~~~~~~~~~~~~~~~~~~~~....~~~~............",
					"....~~~~......................~~~~~~~....~~~~~~~~......................",
					"....~~~~~~~............................................................",
					".....~~~~~~~~..........................................................",
					".....~~..~~~~..........................................................",
					".....~~...~~~..........................................................",
					"....~~~~~~~~~..........................................................",
					"....~~~~~~~~...........................................................",
					".......................................................................",},
				new string[]{ //16
					"~~~~~~~~~~~~~~#########################################################",
					"~~~~~~~~~~~~~~............#......#.............................#.......",
					"~~~~~~~~~~~~~....$...............#.............................#....~~~",
					"~~~~~~~~~~~~.........~~~.........######..............@.............~~~~", //let's see...
					"~~~~~~~~~~~~........~~~~.........#.............................#...~~~~", //zombie only attacks player
					"~~~~~~~~~~~........~~~~~.........#.............................#....~~~", //goblin wants to attack player and collect gold.
					"~~~~~~~~~.........~~.............#..................................~~~", //thirsty goblin wants to do those things and visit water
					"~~~~~~~..........~~.................................................~~~", //rat wants to flee player and visit water and also prefers to be near walls
					"~~~~~...........~~.............................................#....~~~",
					"..............~~~...................................................~~~",
					"............~~~........$.............................................~~",
					"$..........~~~.........................................................",
					"$..........~~..........................................................",
					".......................................................................",
					".......................................................................",
					"...................############........................................",
					"...................#..........#........................................",
					".......................................................................",
					"...................#..........#........................................",
					"...................############........................................",
					".......................................................................",
					".......................................................................",
					".....~~................................................................",
					"....~~~~.................................t.............................",
					"....~~~~~~~...........................z..gr............................",
					".....~~~~~~~~..........................................................",
					".....~~$.~~~~..........................................................",
					".....~~...~~~.................................................$........",
					"....~~~~~~~~~..........................................................",
					"....~~~~~~~~...........................................................",
					".......................................................................",},
				new string[]{ //17
					"............#...................",
					"............#...................",
					"....W..#....#...................",
					".......#....#...................",
					"...#####............@#..........",
					".......#.............#..........",
					".......###############..........",
					"................................",
					"................................",
					"................................",
					"................................",
					"................................",},
			};
			return s[i];
		}
	}
}

