﻿using System;
using SunshineConsole;
using Utilities;
using PosArrays;
namespace DijkstraVisualizer{
	public static partial class DijkstraMain{
		public static void Run(int n,out ConsoleWindow cw){
			switch(n){
			case 0:
			{
				PosArray<char> map = GetMap(6);
				cw = new ConsoleWindow(rows,cols,"Dijkstra Visualization");
				var dijk = map.GetDijkstraMap(x=>map[x] == '@',x=>map[x] == '#');
				Draw(cw,dijk,map,dijk.GetMax(),0);
				break;
			}
			case 1:
			{
				PosArray<char> map = GetMap(8);
				cw = new ConsoleWindow(rows,cols,"Dijkstra Visualization");
				while(true){
					var dijk = map.GetDijkstraMap(x=>map[x] == '@',x=>map[x] == '#');
					Draw(cw,dijk,map,dijk.GetMax(),dijk.GetMin());
					for(int i=0;i<rows;++i){
						for(int j=0;j<cols;++j){
							if(dijk[i,j].IsValidDijkstraValue()){
								dijk[i,j] = dijk[i,j] * -109 / 100;
							}
						}
					}
					Draw(cw,dijk,map,dijk.GetMax(),dijk.GetMin());
					for(int i=0;i<rows;++i){
						for(int j=0;j<cols;++j){
							if(map[i,j] == '@'){
								dijk[i,j] = U.DijkstraMin;
							}
						}
					}
					dijk.RescanDijkstraMap();
					Draw(cw,dijk,map,dijk.GetMax(),dijk.GetMin());
				}
				break;
			}
			case 2:
			{
				PosArray<char> map = GetMap(9);
				cw = new ConsoleWindow(rows,cols,"Dijkstra Visualization");
				while(true){
					var dijk = map.GetDijkstraMap(x=>map[x] == '@' || map[x] == 'W',x=>map[x] == '#');
					Draw(cw,dijk,map,dijk.GetMax(),dijk.GetMin());
					for(int i=0;i<rows;++i){
						for(int j=0;j<cols;++j){
							if(dijk[i,j].IsValidDijkstraValue()){
								dijk[i,j] = dijk[i,j] * -14 / 10;
							}
						}
					}
					Draw(cw,dijk,map,dijk.GetMax(),dijk.GetMin());
					for(int i=0;i<rows;++i){
						for(int j=0;j<cols;++j){
							if(map[i,j] == '@'){
								dijk[i,j] = U.DijkstraMin;
							}
						}
					}
					dijk.RescanDijkstraMap();
					Draw(cw,dijk,map,dijk.GetMax(),dijk.GetMin());
				}
				break;
			}
			case 3:
			{
				PosArray<char> map = GetMap(0);
				cw = new ConsoleWindow(rows,cols,"Dijkstra Visualization");
				while(true){
				var dijk = map.GetDijkstraMap(x=>map[x] == '@' || map[x] == '$',x=>map[x] == '$'? 0 : 0,x=>map[x] == '#',x=>1);
				Draw(cw,dijk,map,dijk.GetMax(),dijk.GetMin());
				dijk = map.GetDijkstraMap(x=>map[x] == '@' || map[x] == '$',x=>map[x] == '$'? -4 : 0,x=>map[x] == '#',x=>1);
				Draw(cw,dijk,map,dijk.GetMax(),dijk.GetMin());
				}
				break;
			}
			case 4:
			{
				PosArray<char> map = GetMap(10);
				cw = new ConsoleWindow(rows,cols,"Dijkstra Visualization");
				//while(true){
				var dijk = map.GetDijkstraMap(x=>map[x] == ' ',x=>map[x] == '#',x=>map[x] == '+'? 2 : 1);
					Draw(cw,dijk,map,dijk.GetMax(),dijk.GetMin());
				//}
				break;
			}
			case 5:
			{
				PosArray<char> map = GetMap(13);
				cw = new ConsoleWindow(rows,cols,"Dijkstra Visualization");
				//while(true){
				var dijk = map.GetDijkstraMap(x=>map[x] == '@',x=>map[x] == '#',x=>map[x] == '+'? 2 : 1);
				Draw(cw,dijk,map,dijk.GetMax(),dijk.GetMin());
				//}
				break;
			}
			case 6:
			{
				PosArray<char> map = GetMap(17);
				cw = new ConsoleWindow(rows,cols,"Dijkstra Visualization");
				while(true){
					var dijk = map.GetDijkstraMap(x=>map[x] == '@',x=>map[x] == '#');
					var dijk2 = dijk.GetDijkstraMap(x=>dijk[x] == 4,x=>map[x] == '#');
					Draw(cw,dijk2,map,dijk2.GetMax(),dijk2.GetMin());
					var dijk3 = dijk.GetDijkstraMap(x=>dijk[x] == 4 && (x.col < 20 || x.row < 3),x=>map[x] == '#');
					Draw(cw,dijk3,map);
				}
				break;
			}
			case 7:
			{
				PosArray<char> map = GetMap(15);
				cw = new ConsoleWindow(rows,cols,"Dijkstra Visualization");
				while(true){
					var dijk = map.GetDijkstraMap(x=>map[x] != '~',x=>false);
					Draw2(cw,dijk,map,dijk.GetMax(),dijk.GetMin());
					var dijk2 = map.GetDijkstraMap(x=>map[x] == '@',x=>dijk[x] > (5+1)/2);
					Draw2(cw,dijk2,map,dijk2.GetMax(),dijk2.GetMin());
				}
				break;
			}
			case 8:
			{
				PosArray<char> map = GetMap(16);
				cw = new ConsoleWindow(rows,cols,"Dijkstra Visualization");
				while(true){
					var dijk = map.GetDijkstraMap(x=>map[x] == '@',x=>map[x] == '#');
					var dijk2 = map.GetDijkstraMap(x=>map[x] == '$',x=>map[x] == '#');
					//Draw3(cw,dijk,map,dijk.GetMax(),dijk.GetMin());
					//Draw3(cw,dijk2,map,dijk2.GetMax(),dijk2.GetMin());
					var dijk3 = new PosArray<int>(rows,cols);
					var dijk4 = new PosArray<int>(rows,cols);
					for(int i=0;i<rows;++i){
						for(int j=0;j<cols;++j){
							if(dijk[i,j].IsValidDijkstraValue()){
								dijk3[i,j] = dijk[i,j] + dijk2[i,j];
							}
							else{
								dijk3[i,j] = U.DijkstraMin;
							}
						}
					}
					Draw3(cw,dijk3,map);
					dijk3.RescanDijkstraMap();
					Draw3(cw,dijk3,map);
				}
				break;
			}
			default:
			cw = null;
			break;
			}
		}
	}
}
